image: node:16

stages:
  - test-lint
  - build

cache:
  key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
  paths:
    - .yarn

.node-init:
  before_script:
    - date
    - echo "Pipeline ID = $CI_PIPELINE_ID"
    - echo "Project name = $CI_PROJECT_NAME"
    - echo "Build ref = $CI_BUILD_REF_NAME"
    - node --version
    - yarn --version
    - yarn config set logFilters --json '[{"code"':' "YN0013", "level"':' "discard"}]'
    - yarn install --immutable

lint:
  stage: test-lint
  extends: .node-init
  script: yarn run lint
  only:
    - main
    - merge_requests

test:
  stage: test-lint
  extends: .node-init
  script: yarn run test:coverage
  only:
    - main
    - merge_requests
  coverage: /^Lines\s*:\s*([^%]+)/
  artifacts:
    reports:
      cobertura: coverage/cobertura-coverage.xml

build:
  stage: build
  needs:
    - lint
    - test
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [ '' ]
  cache: [ ]
  only:
    - main
    - merge_requests
  before_script:
    - >-
      echo "nodeLinker: node-modules" >> .yarnrc.yml
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - >-
      /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "$CI_REGISTRY_IMAGE:$PROJECT_NAME-$CI_COMMIT_REF_SLUG"
      --snapshotMode=redo
      --cache=true
